unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo1DblClick(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Memo1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  flag,altflag:boolean;
  x0,y0,x,n,m,i,j:integer;
  fname,phname,s,ss:string;
  f:Text;

implementation

{$R *.lfm}

{ TForm1 }
{
function FileToString(const FileName: string): AnsiString;
var
  S: TStream;
begin
  S := nil;
  try
    S := TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
    SetLength(Result, S.Size);
    S.Read(PAnsiChar(Result)^, S.Size);
  finally
    S.Free;
  end;
end;
}
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If button<>mbLeft Then
   flag:=false
  Else begin
    flag:=true;
    x0:=x;
    y0:=y
       end
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//грузим картинку
OpenDialog1.Execute;
phname:=OpenDialog1.FileName;
if phname='' then
 begin
 ShowMessage ('Передумали открывать? ;(');
 Exit;
 end;
Image1.Picture.LoadFromFile(phname);
Label1.Caption:=#13+#10+' Имя txt-файла: '+fname+#13+#10+' Изображение : '+phname;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//открываем текст
OpenDialog1.Execute;
fname:=OpenDialog1.FileName;
if fname='' then
 begin
 ShowMessage ('Файл не был выбран.');
 Exit;
 end;
Memo1.Lines.LoadFromFile(utf8toansi(fname));
//Memo1.Text:=Utf8Encode(Memo1.Text);
Label1.Caption:=#13+#10+' Имя txt-файла: '+fname+#13+#10+' Изображение : '+phname;
{
Memo1.Lines.Add(Utf8Encode(a));
Memo1.Lines.Add(AnsiToUtf8(a));
}
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
//сохраняем текст
SaveDialog1.Execute;
fname:=SaveDialog1.FileName;
if fname='' then
 begin
// ShowMessage ('Файл не был выбран.');
 fname:='не указано';
 Exit;
 end;

fname:=fname+'.txt';
Memo1.Lines.SaveToFile(utf8toansi(fname));//сохраняем в анси для икспихи

//пишем файл настроек
   AssignFile (f,ExtractFilePath(Application.ExeName)+'txt-from-image.ini');
   ReWrite(f);
   Writeln (f,fname);
   Writeln (f,phname);
   CloseFile(f);

Label1.Caption:=#13+#10+' Имя txt-файла: '+fname+#13+#10+' Изображение : '+phname;
x:=1;
Timer1.Enabled:=True;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  //сохраняем CSV================================================
SaveDialog1.Execute;
ss:=SaveDialog1.FileName;//нельзя использовать общую переменную, так что SS
if ss='' then
 begin
 Exit;
 end;

ss:=ss+'.csv';
AssignFile (f,ss);
ReWrite(f);

for n:=0 to Memo1.Lines.Count-1 do
  begin
  s:=Memo1.Lines.Strings[n];//получили строку
  ss:='';//формируемая
  j:=i;//количество старых разделителей
  i:=1;//сброс

  ss:=ss+'"';
  for m:=1 to Length(s) do
    begin
    if Edit1.Text=Copy (s,m,1) then//считаем разделители
     begin
     i:=i+1;
     ss:=ss+'"'+Edit1.Text+'"';
     end
    else
        begin
        ss:=ss+Copy (s,m,1);
        end
    end;
  ss:=ss+'"';//закрываем
  if (j<>i) and (n<>0)then
   begin
   ShowMessage ('Количество разделителей в строке №'+IntToStr(n)+' не совпадает с предыдущей'+#13+#10+
  'В прежней: '+IntToStr(j)+'  В текущей'+IntToStr(i));
   end;
//ShowMessage (ss);
 Writeln (f,ss);
 end;
CloseFile(f);

x:=10;
Timer1.Enabled:=True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ShowMessage(Edit1.Text+' - Символ-разделитель полей'+#13+#10+
  #13+#10+
  'В программе допускается вводить данные в виде,'+#13+#10+
  'пригодном для импортирования в таблицы, или базы данных.'+#13+#10+
  ''+#13+#10+
  'Рекомендуется придерживаться следующих правил:'+#13+#10+
  '1. Верхняя строка содержит описание полей.'+#13+#10+
  '2. Поля разделяются символом-разделителем, единым для всего текста (можно менять).'+#13+#10+
  '3. Символ разделителя уникальный для всего текста (запятая не разделитель, т.к. часто присутствует в тексте).'+#13+#10+
  '4. Количество полей должно быть одинаковым для всего текста.'+#13+#10+
  #13+#10+
  'ПРИМЕР: четыре поля с тремя введенными записями. Разделитель - ^'+#13+#10+
  #13+#10+
  'Номер п/п'+Edit1.Text+'Содержание'+Edit1.Text+'Дата'+Edit1.Text+'Примечания'+#13+#10+
  '1'+Edit1.Text+'Прибор бытовой'+Edit1.Text+'12-07-2013'+Edit1.Text+'Мясорубка'+#13+#10+
  '2'+Edit1.Text+'Прибор электрический'+Edit1.Text+'04-09-2013'+Edit1.Text+'Утюг'+#13+#10+
  '3'+Edit1.Text+'Моющие средства'+Edit1.Text+'16-05-2013'+Edit1.Text+'Pril'+#13+#10+
  #13+#10+
  'При последующем импорте в LibreOffice Calc (или Excell), указать символ "^".'+#13+#10+
  #13+#10+'Удерживайте клавишу [Alt] для перемещения окна с текстом');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//==================== СТАРТ ПРОГРАММЫ ====================
ScrollBar1.Position:=950;
ScrollBar2.Position:=10;

fname:='не указано';
phname:='встроенное';

//читаем файл настроек
if FileExists (ExtractFilePath(Application.ExeName)+'txt-from-image.ini')=true then
   begin
   AssignFile (f,ExtractFilePath(Application.ExeName)+'txt-from-image.ini');
   Reset(f);
   Readln (f,fname);
   Readln (f,phname);
   CloseFile(f);
   end;

//fname:=utf8toansi(fname);//конвертим для открытия
if FileExists (utf8toansi(fname))=true then
   begin
   Memo1.Lines.LoadFromFile(utf8toansi(fname));
   end;
//fname:=ansitoutf8(fname);//приходится перед загрузкой конвертить, затем назад

if FileExists (utf8toansi(phname))=true then
   begin
   Image1.Picture.LoadFromFile(phname);
   end;

Label1.Caption:=#13+#10+' Имя txt-файла: '+fname+#13+#10+' Изображение : '+phname;
















end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
    if Key=18 then//если нажата [Alt] то ставим флажок, иначе снимаем
   begin
   altflag:=true;
   end
  else
  altflag:=false;
end;

procedure ScaleBitmap(aBitmap: TBitmap;Scale: Single);
var
  tmp: TBitmap;
begin
  tmp := TBitmap.Create;
  try
    tmp.Width := Round(aBitmap.Width * Scale);
    tmp.Height := Round(aBitmap.Height * Scale);
    tmp.Canvas.StretchDraw(Bounds(0,0,tmp.Width,tmp.Height), aBitmap);
    aBitmap.Assign(tmp);
  finally
    tmp.Free;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If flag Then begin //Если флажок установлен, т.е. нажата левая копка мыши
    (Sender As TImage).Left:=(Sender As TImage).Left+x-x0;
    (Sender As TImage).Top:=(Sender As TImage).Top+y-y0
  //Наш Image начинает перемещаться
               end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   flag:=false;
end;

procedure TForm1.Memo1DblClick(Sender: TObject);
begin
  if fname='не указано' then
 begin
 ShowMessage ('Для быстрого сохранения необходимо хоть один раз сохранить текст в файл');
 ShowMessage ('Ничего не сохранили ;((');
 Exit;
 end;


Memo1.Lines.SaveToFile(utf8toansi(fname));//сохраняем в анси для икспихи
//файл настроек
   AssignFile (f,ExtractFilePath(Application.ExeName)+'txt-from-image.ini');
   ReWrite(f);
   Writeln (f,fname);
   Writeln (f,phname);
   CloseFile(f);

Label1.Caption:=#13+#10+' Имя txt-файла: '+fname+#13+#10+' Изображение : '+phname;
x:=1;
Timer1.Enabled:=True;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
altflag:=false;
end;

procedure TForm1.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//он маус-даун текст
    If button<>mbLeft Then
   flag:=false
  Else begin
    flag:=true;
    x0:=x;
    y0:=y
       end
end;

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
//он маус муве
    if altflag=false then
     begin
     Exit;
     end;


  If flag Then begin //Если флажок установлен, т.е. нажата левая копка мыши
    (Sender As TMemo).Left:=(Sender As TMemo).Left+x-x0;
    (Sender As TMemo).Top:=(Sender As TMemo).Top+y-y0
     end;

end;

procedure TForm1.Memo1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//он мауз ап
  flag:=false;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Image1.Height:=ScrollBar1.Position;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  Memo1.Font.Size:=ScrollBar2.Position;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
      if x>240 then
  begin
  Label1.Color:=clSkyBlue;
  Timer1.Enabled:=False;
  Label1.Refresh;
  end
    else
    begin
    x:=x+30;
    Label1.Color:=RGBToColor(255-x,x,0);
    Label1.Refresh;
    end;
end;

end.

